<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: LocoStepper Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classLocoStepper.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classLocoStepper-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">LocoStepper Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p>Support for stepper motors with acceleration etc.  
 <a href="classLocoStepper.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="LocoStepper_8h_source.html">LocoStepper.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:abefb91b8c07a88e6f5026e0805acdf74"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#abefb91b8c07a88e6f5026e0805acdf74">LocoStepper</a> (uint8_t pin1, uint8_t pin2, uint8_t *inpStep2 = NULL)</td></tr>
<tr class="separator:abefb91b8c07a88e6f5026e0805acdf74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4a6ac8d2b1eefbe562e09b4762e4bd0"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#aa4a6ac8d2b1eefbe562e09b4762e4bd0">LocoStepper</a> (uint8_t pin1, uint8_t pin2, uint8_t pin3, uint8_t pin4, uint8_t *inpStep2 = NULL)</td></tr>
<tr class="separator:aa4a6ac8d2b1eefbe562e09b4762e4bd0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae0792a7479f1a52018d948c22600fab0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#ae0792a7479f1a52018d948c22600fab0">moveTo</a> (long absolute)</td></tr>
<tr class="separator:ae0792a7479f1a52018d948c22600fab0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8be0715eaa122dc111359e9dd06168d9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a8be0715eaa122dc111359e9dd06168d9">move</a> (long relative)</td></tr>
<tr class="separator:a8be0715eaa122dc111359e9dd06168d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4045493f8395d7b3dc0a8e1477b3596"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run</a> ()</td></tr>
<tr class="separator:ae4045493f8395d7b3dc0a8e1477b3596"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5c23466938595842934a2331cfeb21e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#ae5c23466938595842934a2331cfeb21e">setSpeed</a> (float speed)</td></tr>
<tr class="separator:ae5c23466938595842934a2331cfeb21e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75ea615634b59ab0880cad22f7b40c48"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a75ea615634b59ab0880cad22f7b40c48">speed</a> ()</td></tr>
<tr class="separator:a75ea615634b59ab0880cad22f7b40c48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2716957fdca4c048fcf5ba65e89abc95"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a2716957fdca4c048fcf5ba65e89abc95">distanceToGo</a> ()</td></tr>
<tr class="separator:a2716957fdca4c048fcf5ba65e89abc95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92a8648eb49926cdb11f96cdc6de17b4"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a92a8648eb49926cdb11f96cdc6de17b4">targetPosition</a> ()</td></tr>
<tr class="separator:a92a8648eb49926cdb11f96cdc6de17b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f619bbe60bc7f71b64d0447b7c6b0ad"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a3f619bbe60bc7f71b64d0447b7c6b0ad">currentPosition</a> ()</td></tr>
<tr class="separator:a3f619bbe60bc7f71b64d0447b7c6b0ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ff4c5df6aa76c31d05c357f48bf1223"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a0ff4c5df6aa76c31d05c357f48bf1223">setCurrentPosition</a> (long position)</td></tr>
<tr class="separator:a0ff4c5df6aa76c31d05c357f48bf1223"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66ed72e5f551d8ffe86b00e642c832f2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a66ed72e5f551d8ffe86b00e642c832f2">disableOutputs</a> ()</td></tr>
<tr class="separator:a66ed72e5f551d8ffe86b00e642c832f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10a8e0c2464a99df13ff50f675e7b4e0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">enableOutputs</a> ()</td></tr>
<tr class="separator:a10a8e0c2464a99df13ff50f675e7b4e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad542ef50f02428220ab20af161e5a541"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#ad542ef50f02428220ab20af161e5a541">setMinPulseWidth</a> (unsigned int minWidth)</td></tr>
<tr class="separator:ad542ef50f02428220ab20af161e5a541"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a293e88856ea392788806ab4413776d31"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a293e88856ea392788806ab4413776d31">step</a> (uint8_t step)</td></tr>
<tr class="separator:a293e88856ea392788806ab4413776d31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a819e566cc3c4586f5a2c095983fa52f3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a819e566cc3c4586f5a2c095983fa52f3">step2</a> (uint8_t step)</td></tr>
<tr class="separator:a819e566cc3c4586f5a2c095983fa52f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b2f0bee97af34b780e8d715eedf7b4d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLocoStepper.html#a3b2f0bee97af34b780e8d715eedf7b4d">step4</a> (uint8_t step)</td></tr>
<tr class="separator:a3b2f0bee97af34b780e8d715eedf7b4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This defines a single 2 or 4 pin stepper motor, or stepper moter with fdriver chip, with optional absolute positioning commands etc. Multiple simultaneous steppers are supported, all moving at different speeds.</p>
<dl class="section user"><dt>Operation</dt><dd>This module operates by computing a step time in microseconds. The step time is recomputed after each step and after speed and acceleration parameters are changed by the caller. The time of each step is recorded in microseconds. The <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> function steps the motor if a new step is due. The <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> function must be called frequently until the motor is in the desired position, after which time <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> will do nothing.</dd></dl>
<dl class="section user"><dt>Positioning</dt><dd>Positions are specified by a signed long integer. At construction time, the current position of the motor is consider to be 0. Positive positions are clockwise from the initial position; negative positions are anticlockwise. The curent position can be altered for instance after initialization positioning.</dd></dl>
<dl class="section user"><dt>Caveats</dt><dd>This is an open loop controller: If the motor stalls or is oversped, LocoStepper will not have a correct idea of where the motor really is (since there is no feedback of the motor's real position. We only know where we <em>think</em> it is, relative to the initial starting point).</dd></dl>
<p>The fastest motor speed that can be reliably supported is 4000 steps per second (4 kHz) at a clock frequency of 16 MHz. However, any speed less than that down to very slow speeds (much less than one per second) are also supported, provided the <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> function is called frequently enough to step the motor whenever required for the speed set. </p>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8h_source.html#l00081">81</a> of file <a class="el" href="LocoStepper_8h_source.html">LocoStepper.h</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="abefb91b8c07a88e6f5026e0805acdf74"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LocoStepper::LocoStepper </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>pin1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>pin2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>inpStep2</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor. You can have multiple simultaneous steppers, all moving at different speeds and accelerations, provided you call their <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> functions at frequent enough intervals. Current Position is set to 0, target position is set to 0. The motor pins will be initialised to OUTPUT mode during the constructor by a call to <a class="el" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">enableOutputs()</a>. inpSteps pointer argument gives the caller the possibility to fix himself the sequence of pins activation. If nothing is specifed, a default value will be used: </p><pre class="fragment">/// B01, B11, B10, B00 
/// </pre> 
<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00021">21</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="aa4a6ac8d2b1eefbe562e09b4762e4bd0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LocoStepper::LocoStepper </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>pin1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>pin2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>pin3</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>pin4</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>inpStep2</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor. You can have multiple simultaneous steppers, all moving at different speeds and accelerations, provided you call their <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> functions at frequent enough intervals. Current Position is set to 0, target position is set to 0. The motor pins will be initialised to OUTPUT mode during the constructor by a call to <a class="el" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">enableOutputs()</a>. inpSteps pointer argument gives the caller the possibility to fix himself the sequence of pins activation. If nothing is specifed, a default value will be used: </p><pre class="fragment">/// B1010, B0110, B0101, B1001
/// </pre> 
<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00029">29</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a3f619bbe60bc7f71b64d0447b7c6b0ad"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long LocoStepper::currentPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The currently motor position. </p><dl class="section return"><dt>Returns</dt><dd>the current motor position in steps. Positive is clockwise from the 0 position. </dd></dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00118">118</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a66ed72e5f551d8ffe86b00e642c832f2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::disableOutputs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Disable motor pin outputs by setting them all LOW Depending on the design of your electronics this may turn off the power to the motor coils, saving power. This is useful to support Arduino low power modes: disable the outputs during sleep and then reenable with <a class="el" href="classLocoStepper.html#a10a8e0c2464a99df13ff50f675e7b4e0">enableOutputs()</a> before stepping again. </p>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00181">181</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a2716957fdca4c048fcf5ba65e89abc95"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long LocoStepper::distanceToGo </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The distance from the current position to the target position. </p><dl class="section return"><dt>Returns</dt><dd>the distance from the current position to the target position in steps. Positive is clockwise from the current position. </dd></dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00108">108</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a10a8e0c2464a99df13ff50f675e7b4e0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::enableOutputs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Enable motor pin outputs by setting the motor pins to OUTPUT mode. Called automatically by the constructor. </p>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00191">191</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a8be0715eaa122dc111359e9dd06168d9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::move </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>relative</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set the target position relative to the current position </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">relative</td><td>The desired position relative to the current position. Negative is anticlockwise from the current position. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00063">63</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae0792a7479f1a52018d948c22600fab0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::moveTo </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>absolute</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set the target position. The <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a> function will try to move the motor from the current position to the target position set by the most recent call to this function. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">absolute</td><td>The desired absolute position. Negative is anticlockwise from the 0 position. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00049">49</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae4045493f8395d7b3dc0a8e1477b3596"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">boolean LocoStepper::run </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Poll the motor and step it if a step is due. You must call this as fequently as possible, but at least once per minimum step interval, preferably in your main loop. </p><dl class="section return"><dt>Returns</dt><dd>true if the motor is still going to the target position. </dd></dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00072">72</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a0ff4c5df6aa76c31d05c357f48bf1223"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::setCurrentPosition </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>position</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Resets the current position of the motor, so that wherever the mottor happens to be right now is considered to be the new position. Useful for setting a zero position on a stepper after an initial hardware positioning move. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">position</td><td>The position in steps of wherever the motor happens to be right now. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00124">124</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ad542ef50f02428220ab20af161e5a541"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::setMinPulseWidth </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>minWidth</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the minimum pulse width allowed by the stepper driver. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">minWidth</td><td>The minimum pulse width in microseconds. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00201">201</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae5c23466938595842934a2331cfeb21e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::setSpeed </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>speed</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the desired constant speed for use with <a class="el" href="classLocoStepper.html#ae4045493f8395d7b3dc0a8e1477b3596">run()</a>. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">speed</td><td>The desired constant speed in steps per second. Positive is clockwise. Speeds of more than 1000 steps per second are unreliable. Very slow speeds may be set (eg 0.00027777 for once per hour, approximately. Speed accuracy depends on the Arduino crystal. Jitter depends on how frequently you call the runSpeed() function. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00129">129</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a75ea615634b59ab0880cad22f7b40c48"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">float LocoStepper::speed </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The most recently set speed </p><dl class="section return"><dt>Returns</dt><dd>the most recent speed in steps per second </dd></dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00135">135</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a293e88856ea392788806ab4413776d31"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::step </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>step</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Called to execute a step. Only called when a new step is required. Subclasses may override to implement new stepping interfaces. The default calls step1(), <a class="el" href="classLocoStepper.html#a819e566cc3c4586f5a2c095983fa52f3">step2()</a> or <a class="el" href="classLocoStepper.html#a3b2f0bee97af34b780e8d715eedf7b4d">step4()</a> depending on the number of pins defined for the stepper. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">step</td><td>The current step phase number (0 to 3) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a819e566cc3c4586f5a2c095983fa52f3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::step2 </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>step</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Called to execute a step on a 2 pin motor. Only called when a new step is required. Subclasses may override to implement new stepping interfaces. The default sets or clears the outputs of pin1 and pin2 </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">step</td><td>The current step phase number (0 to 3) </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00143">143</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a3b2f0bee97af34b780e8d715eedf7b4d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void LocoStepper::step4 </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>step</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Called to execute a step on a 4 pin motor. Only called when a new step is required. Subclasses may override to implement new stepping interfaces. The default sets or clears the outputs of pin1, pin2, pin3, pin4. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">step</td><td>The current step phase number (0 to 3) </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00159">159</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a92a8648eb49926cdb11f96cdc6de17b4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long LocoStepper::targetPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The most recently set target position. </p><dl class="section return"><dt>Returns</dt><dd>the target position in steps. Positive is clockwise from the 0 position. </dd></dl>

<p class="definition">Definition at line <a class="el" href="LocoStepper_8cpp_source.html#l00113">113</a> of file <a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="LocoStepper_8h_source.html">LocoStepper.h</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="LocoStepper_8cpp_source.html">LocoStepper.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classLocoStepper.html">LocoStepper</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
